Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 3938)
@@ -27,4 +27,6 @@
    USE wrk_nemo        ! work arrays
    USE prtctl          ! Print control
+   USE lib_fortran     ! to use key_nosignedzero
+   USE limvar          ! clem for ice thickness correction
 
    IMPLICIT NONE
@@ -35,6 +37,7 @@
    REAL(wp)  ::   epsi06 = 1.e-06_wp   ! constant values
    REAL(wp)  ::   epsi03 = 1.e-03_wp  
-   REAL(wp)  ::   zeps10 = 1.e-10_wp  
+   REAL(wp)  ::   epsi10 = 1.e-10_wp  
    REAL(wp)  ::   epsi16 = 1.e-16_wp
+   REAL(wp)  ::   epsi20 = 1.e-20_wp
    REAL(wp)  ::   rzero  = 0._wp   
    REAL(wp)  ::   rone   = 1._wp
@@ -65,8 +68,9 @@
       INTEGER, INTENT(in) ::   kt   ! number of iteration
       !
-      INTEGER  ::   ji, jj, jk, jl, layer   ! dummy loop indices
+      INTEGER  ::   ji, jj, jk, jl, jm, layer   ! dummy loop indices
+      INTEGER  ::   jbnd1, jbnd2
       INTEGER  ::   initad                  ! number of sub-timestep for the advection
       INTEGER  ::   ierr                    ! error status
-      REAL(wp) ::   zindb  , zindsn , zindic      ! local scalar
+      REAL(wp) ::   zindb  , zindsn , zindic, zindh, zinda      ! local scalar
       REAL(wp) ::   zusvosn, zusvoic, zbigval     !   -      -
       REAL(wp) ::   zcfl , zusnit , zrtt          !   -      -
@@ -76,4 +80,10 @@
       REAL(wp), POINTER, DIMENSION(:,:,:)    ::   zs0ice, zs0sn, zs0a, zs0c0 , zs0sm , zs0oi
       REAL(wp), POINTER, DIMENSION(:,:,:,:)  ::   zs0e
+      REAL(wp) :: zchk_v_i, zchk_smv, zchk_fs, zchk_fw, zchk_v_i_b, zchk_smv_b, zchk_fs_b, zchk_fw_b ! Check conservation (C Rousset)
+      ! mass and salt flux (clem)
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zviold   ! old ice volume...
+      ! correct ice thickness (clem)
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zaiold, zhimax   ! old ice concentration
+      REAL(wp) :: zdv, zda, zvi, zvs, zsmv
       !!---------------------------------------------------------------------
 
@@ -81,4 +91,18 @@
       CALL wrk_alloc( jpi, jpj, jpl, zs0ice, zs0sn, zs0a, zs0c0 , zs0sm , zs0oi )
       CALL wrk_alloc( jpi, jpj, jkmax, jpl, zs0e )
+
+      CALL wrk_alloc( jpi,jpj,jpl,zviold )   ! clem
+      CALL wrk_alloc( jpi,jpj,jpl,zaiold, zhimax )   ! clem
+
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_v_i_b = glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_smv_b = glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_fw_b  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) )
+         zchk_fs_b  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) )
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
 
       IF( numit == nstart .AND. lwp ) THEN
@@ -95,6 +119,24 @@
       IF( ln_limdyn ) THEN          !   Advection of sea ice properties   !
          !                          !-------------------------------------!
-         !
-
+         ! mass and salt flux init (clem)
+         zviold(:,:,:)  = v_i(:,:,:)
+
+         !--- Thickness correction init. (clem) -------------------------------
+         CALL lim_var_glo2eqv
+         zaiold(:,:,:) = a_i(:,:,:)
+         !---------------------------------------------------------------------
+         ! Record max of the surrounding ice thicknesses for correction in limupdate
+         ! in case advection creates ice too thick.
+         !---------------------------------------------------------------------
+         zhimax(:,:,:) = ht_i(:,:,:)
+         DO jl = 1, jpl
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  zhimax(ji,jj,jl) = MAXVAL( ht_i(ji-1:ji+1,jj-1:jj+1,jl) )
+               END DO
+            END DO
+            CALL lbc_lnk(zhimax(:,:,jl),'T',1.)
+         END DO
+         
          !-------------------------
          ! transported fields                                        
@@ -125,5 +167,5 @@
 !         ENDIF
 !!gm end
-         initad = 1 + INT( MAX( rzero, SIGN( rone, zcfl-0.5 ) ) )
+         initad = 1 + NINT( MAX( rzero, SIGN( rone, zcfl-0.5 ) ) )
          zusnit = 1.0 / REAL( initad ) 
          IF( zcfl > 0.5 .AND. lwp )   &
@@ -134,7 +176,7 @@
             DO jk = 1,initad
                CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0ow (:,:), sxopw(:,:),   &             !--- ice open water area
-                  &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
+                   &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
                CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0ow (:,:), sxopw(:,:),   &
-                  &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
+                   &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
                DO jl = 1, jpl
                   CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0ice(:,:,jl), sxice(:,:,jl),   &    !--- ice volume  ---
@@ -174,39 +216,38 @@
          ELSE
             DO jk = 1, initad
-               CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0ow (:,:), sxopw(:,:),   &             !--- ice open water area
-                  &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
-               CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0ow (:,:), sxopw(:,:),   &
-                  &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
+               CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0ow (:,:), sxopw(:,:),   &             !--- ice open water area
+                   &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
+               CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0ow (:,:), sxopw(:,:),   &
+                   &                                       sxxopw(:,:), syopw(:,:), syyopw(:,:), sxyopw(:,:)  )
                DO jl = 1, jpl
-                  CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0ice(:,:,jl), sxice(:,:,jl),   &    !--- ice volume  ---
+                  CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0ice(:,:,jl), sxice(:,:,jl),   &    !--- ice volume  ---
                      &                                       sxxice(:,:,jl), syice(:,:,jl), syyice(:,:,jl), sxyice(:,:,jl)  )
-                  CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0ice(:,:,jl), sxice(:,:,jl),   &
+                  CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0ice(:,:,jl), sxice(:,:,jl),   &
                      &                                       sxxice(:,:,jl), syice(:,:,jl), syyice(:,:,jl), sxyice(:,:,jl)  )
-                  CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0sn (:,:,jl), sxsn (:,:,jl),   &    !--- snow volume  ---
+                  CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0sn (:,:,jl), sxsn (:,:,jl),   &    !--- snow volume  ---
                      &                                       sxxsn (:,:,jl), sysn (:,:,jl), syysn (:,:,jl), sxysn (:,:,jl)  )
-                  CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0sn (:,:,jl), sxsn (:,:,jl),   &
+                  CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0sn (:,:,jl), sxsn (:,:,jl),   &
                      &                                       sxxsn (:,:,jl), sysn (:,:,jl), syysn (:,:,jl), sxysn (:,:,jl)  )
-                  CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0sm (:,:,jl), sxsal(:,:,jl),   &    !--- ice salinity ---
+                  CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0sm (:,:,jl), sxsal(:,:,jl),   &    !--- ice salinity ---
                      &                                       sxxsal(:,:,jl), sysal(:,:,jl), syysal(:,:,jl), sxysal(:,:,jl)  )
-                  CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0sm (:,:,jl), sxsal(:,:,jl),   &
+                  CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0sm (:,:,jl), sxsal(:,:,jl),   &
                      &                                       sxxsal(:,:,jl), sysal(:,:,jl), syysal(:,:,jl), sxysal(:,:,jl)  )
-
-                  CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0oi (:,:,jl), sxage(:,:,jl),   &   !--- ice age      ---
+                  CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0oi (:,:,jl), sxage(:,:,jl),   &   !--- ice age      ---
                      &                                       sxxage(:,:,jl), syage(:,:,jl), syyage(:,:,jl), sxyage(:,:,jl)  )
-                  CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0oi (:,:,jl), sxage(:,:,jl),   &
+                  CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0oi (:,:,jl), sxage(:,:,jl),   &
                      &                                       sxxage(:,:,jl), syage(:,:,jl), syyage(:,:,jl), sxyage(:,:,jl)  )
-                  CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0a  (:,:,jl), sxa  (:,:,jl),   &   !--- ice concentrations ---
+                  CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0a  (:,:,jl), sxa  (:,:,jl),   &   !--- ice concentrations ---
                      &                                       sxxa  (:,:,jl), sya  (:,:,jl), syya  (:,:,jl), sxya  (:,:,jl)  )
-                  CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0a  (:,:,jl), sxa  (:,:,jl),   &
+                  CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0a  (:,:,jl), sxa  (:,:,jl),   &
                      &                                       sxxa  (:,:,jl), sya  (:,:,jl), syya  (:,:,jl), sxya  (:,:,jl)  )
-                  CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0c0 (:,:,jl), sxc0 (:,:,jl),   &  !--- snow heat contents ---
+                  CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0c0 (:,:,jl), sxc0 (:,:,jl),   &  !--- snow heat contents ---
                      &                                       sxxc0 (:,:,jl), syc0 (:,:,jl), syyc0 (:,:,jl), sxyc0 (:,:,jl)  )
-                  CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0c0 (:,:,jl), sxc0 (:,:,jl),   &
+                  CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0c0 (:,:,jl), sxc0 (:,:,jl),   &
                      &                                       sxxc0 (:,:,jl), syc0 (:,:,jl), syyc0 (:,:,jl), sxyc0 (:,:,jl)  )
                   DO layer = 1, nlay_i                                                           !--- ice heat contents ---
-                     CALL lim_adv_y( zusnit, v_ice, rzero, zsm, zs0e(:,:,layer,jl), sxe (:,:,layer,jl),   & 
+                     CALL lim_adv_y( zusnit, v_ice, rone, zsm, zs0e(:,:,layer,jl), sxe (:,:,layer,jl),   & 
                         &                                       sxxe(:,:,layer,jl), sye (:,:,layer,jl),   &
                         &                                       syye(:,:,layer,jl), sxye(:,:,layer,jl) )
-                     CALL lim_adv_x( zusnit, u_ice, rone , zsm, zs0e(:,:,layer,jl), sxe (:,:,layer,jl),   & 
+                     CALL lim_adv_x( zusnit, u_ice, rzero , zsm, zs0e(:,:,layer,jl), sxe (:,:,layer,jl),   & 
                         &                                       sxxe(:,:,layer,jl), sye (:,:,layer,jl),   &
                         &                                       syye(:,:,layer,jl), sxye(:,:,layer,jl) )
@@ -270,13 +311,13 @@
             END DO
 
-            CALL lim_hdf( zs0ice (:,:,jl) )
-            CALL lim_hdf( zs0sn  (:,:,jl) )
-            CALL lim_hdf( zs0sm  (:,:,jl) )
-            CALL lim_hdf( zs0oi  (:,:,jl) )
-            CALL lim_hdf( zs0a   (:,:,jl) )
-            CALL lim_hdf( zs0c0  (:,:,jl) )
-            DO jk = 1, nlay_i
-               CALL lim_hdf( zs0e (:,:,jk,jl) )
-            END DO
+             CALL lim_hdf( zs0ice (:,:,jl) )
+             CALL lim_hdf( zs0sn  (:,:,jl) )
+             CALL lim_hdf( zs0sm  (:,:,jl) )
+             CALL lim_hdf( zs0oi  (:,:,jl) )
+             CALL lim_hdf( zs0a   (:,:,jl) )
+             CALL lim_hdf( zs0c0  (:,:,jl) )
+             DO jk = 1, nlay_i
+                CALL lim_hdf( zs0e (:,:,jk,jl) )
+             END DO
          END DO
 
@@ -284,16 +325,16 @@
          !  Remultiply everything by ice area
          !-----------------------------------------
-         zs0ow(:,:) = MAX( rzero, zs0ow(:,:) * area(:,:) )
-         DO jl = 1, jpl
-            zs0ice(:,:,jl) = MAX( rzero, zs0ice(:,:,jl) * area(:,:) )    !!bug:  est-ce utile
-            zs0sn (:,:,jl) = MAX( rzero, zs0sn (:,:,jl) * area(:,:) )    !!bug:  cf /area  juste apres
-            zs0sm (:,:,jl) = MAX( rzero, zs0sm (:,:,jl) * area(:,:) )    !!bug:  cf /area  juste apres
-            zs0oi (:,:,jl) = MAX( rzero, zs0oi (:,:,jl) * area(:,:) )
-            zs0a  (:,:,jl) = MAX( rzero, zs0a  (:,:,jl) * area(:,:) )    !! suppress both change le resultat
-            zs0c0 (:,:,jl) = MAX( rzero, zs0c0 (:,:,jl) * area(:,:) )
-            DO jk = 1, nlay_i
-               zs0e(:,:,jk,jl) = MAX( rzero, zs0e (:,:,jk,jl) * area(:,:) )
-            END DO ! jk
-         END DO ! jl
+         !clem zs0ow(:,:) = MAX( rzero, zs0ow(:,:) * area(:,:) )
+         !clem DO jl = 1, jpl
+         !clem    zs0ice(:,:,jl) = MAX( rzero, zs0ice(:,:,jl) * area(:,:) )    !!bug:  est-ce utile
+         !clem    zs0sn (:,:,jl) = MAX( rzero, zs0sn (:,:,jl) * area(:,:) )    !!bug:  cf /area  juste apres
+         !clem    zs0sm (:,:,jl) = MAX( rzero, zs0sm (:,:,jl) * area(:,:) )    !!bug:  cf /area  juste apres
+         !clem    zs0oi (:,:,jl) = MAX( rzero, zs0oi (:,:,jl) * area(:,:) )
+         !clem    zs0a  (:,:,jl) = MAX( rzero, zs0a  (:,:,jl) * area(:,:) )    !! suppress both change le resultat
+         !clem    zs0c0 (:,:,jl) = MAX( rzero, zs0c0 (:,:,jl) * area(:,:) )
+         !clem    DO jk = 1, nlay_i
+         !clem       zs0e(:,:,jk,jl) = MAX( rzero, zs0e (:,:,jk,jl) * area(:,:) )
+         !clem    END DO ! jk
+         !clem END DO ! jl
 
          !------------------------------------------------------------------------------!
@@ -305,19 +346,19 @@
          !--------------------------------------------------
 
-         DO jl = 1, jpl
-            DO jk = 1, nlay_i
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zs0e(ji,jj,jk,jl) = MAX( rzero, zs0e(ji,jj,jk,jl) / area(ji,jj) )
-                  END DO
-               END DO
-            END DO
-         END DO
-
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zs0ow(ji,jj) = MAX( rzero, zs0ow (ji,jj) / area(ji,jj) )
-            END DO
-         END DO
+         !clem DO jl = 1, jpl
+         !clem    DO jk = 1, nlay_i
+         !clem       DO jj = 1, jpj
+         !clem          DO ji = 1, jpi
+         !clem             zs0e(ji,jj,jk,jl) = MAX( rzero, zs0e(ji,jj,jk,jl) / area(ji,jj) )
+         !clem          END DO
+         !clem       END DO
+         !clem    END DO
+         !clem END DO
+
+         !clem DO jj = 1, jpj
+         !clem    DO ji = 1, jpi
+         !clem       zs0ow(ji,jj) = MAX( rzero, zs0ow (ji,jj) / area(ji,jj) )
+         !clem    END DO
+         !clem END DO
 
          zs0at(:,:) = 0._wp
@@ -325,10 +366,16 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zs0sn (ji,jj,jl) = MAX( rzero, zs0sn (ji,jj,jl)/area(ji,jj) )
-                  zs0ice(ji,jj,jl) = MAX( rzero, zs0ice(ji,jj,jl)/area(ji,jj) )
-                  zs0sm (ji,jj,jl) = MAX( rzero, zs0sm (ji,jj,jl)/area(ji,jj) )
-                  zs0oi (ji,jj,jl) = MAX( rzero, zs0oi (ji,jj,jl)/area(ji,jj) )
-                  zs0a  (ji,jj,jl) = MAX( rzero, zs0a  (ji,jj,jl)/area(ji,jj) )
-                  zs0c0 (ji,jj,jl) = MAX( rzero, zs0c0 (ji,jj,jl)/area(ji,jj) )
+                 !clem  zs0sn (ji,jj,jl) = MAX( rzero, zs0sn (ji,jj,jl)/area(ji,jj) )
+                 !clem  zs0ice(ji,jj,jl) = MAX( rzero, zs0ice(ji,jj,jl)/area(ji,jj) )
+                 !clem  zs0sm (ji,jj,jl) = MAX( rzero, zs0sm (ji,jj,jl)/area(ji,jj) )
+                 !clem  zs0oi (ji,jj,jl) = MAX( rzero, zs0oi (ji,jj,jl)/area(ji,jj) )
+                 !clem  zs0a  (ji,jj,jl) = MAX( rzero, zs0a  (ji,jj,jl)/area(ji,jj) )
+                 !clem  zs0c0 (ji,jj,jl) = MAX( rzero, zs0c0 (ji,jj,jl)/area(ji,jj) )
+                  zs0sn (ji,jj,jl) = MAX( rzero, zs0sn (ji,jj,jl) )
+                  zs0ice(ji,jj,jl) = MAX( rzero, zs0ice(ji,jj,jl) )
+                  zs0sm (ji,jj,jl) = MAX( rzero, zs0sm (ji,jj,jl) )
+                  zs0oi (ji,jj,jl) = MAX( rzero, zs0oi (ji,jj,jl) )
+                  zs0a  (ji,jj,jl) = MAX( rzero, zs0a  (ji,jj,jl) )
+                  zs0c0 (ji,jj,jl) = MAX( rzero, zs0c0 (ji,jj,jl) )
                   zs0at (ji,jj)    = zs0at(ji,jj) + zs0a(ji,jj,jl)
                END DO
@@ -341,5 +388,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zindb        = MAX( 0._wp , SIGN( 1.0, zs0at(ji,jj) - zeps10) )
+               zindb        = MAX( 0._wp , SIGN( 1.0, zs0at(ji,jj) - epsi10) )
                zs0ow(ji,jj) = ( 1._wp - zindb ) + zindb * MAX( zs0ow(ji,jj), 0._wp )
                ato_i(ji,jj) = zs0ow(ji,jj)
@@ -347,27 +394,78 @@
          END DO
 
+         !
+         !
          DO jl = 1, jpl         ! Remove very small areas 
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zindb         = MAX( 0.0 , SIGN( 1.0, zs0a(ji,jj,jl) - zeps10) )
+                  zvi = zs0ice(ji,jj,jl)
+                  zvs = zs0sn(ji,jj,jl)
                   !
-                  zs0a(ji,jj,jl) = zindb * MIN( zs0a(ji,jj,jl), 0.99 )
+                  zindb         = MAX( 0.0 , SIGN( 1.0, zs0a(ji,jj,jl) - epsi10) )
+                  !
+                  !zs0a(ji,jj,jl) = zindb * MIN( zs0a(ji,jj,jl), 0.99 )
                   v_s(ji,jj,jl)  = zindb * zs0sn (ji,jj,jl) 
                   v_i(ji,jj,jl)  = zindb * zs0ice(ji,jj,jl)
                   !
-                  zindsn         = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - zeps10 ) )
-                  zindic         = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - zeps10 ) )
+                  zindsn         = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi10 ) )
+                  zindic         = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) )
                   zindb          = MAX( zindsn, zindic )
+                  !
                   zs0a(ji,jj,jl) = zindb  * zs0a(ji,jj,jl) !ice concentration
                   a_i (ji,jj,jl) = zs0a(ji,jj,jl)
                   v_s (ji,jj,jl) = zindsn * v_s(ji,jj,jl)
                   v_i (ji,jj,jl) = zindic * v_i(ji,jj,jl)
+                  !
+                  ! Update mass fluxes (clem)
+                  rdmicif(ji,jj) = rdmicif(ji,jj) + ( v_i(ji,jj,jl) - zvi ) * rhoic 
+                  rdmsnif(ji,jj) = rdmsnif(ji,jj) + ( v_s(ji,jj,jl) - zvs ) * rhosn 
+              END DO
+            END DO
+         END DO
+
+         !--- Thickness correction in case too high (clem) --------------------------------------------------------
+         CALL lim_var_glo2eqv
+         DO jl = 1, jpl
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+
+                  IF ( v_i(ji,jj,jl) > 0. ) THEN
+                     zvi = v_i(ji,jj,jl)
+                     zvs = v_s(ji,jj,jl)
+                     zdv = v_i(ji,jj,jl) - zviold(ji,jj,jl)   
+                     !zda = a_i(ji,jj,jl) - zaiold(ji,jj,jl)   
+                     
+                     IF ( ( zdv > 0.0 .AND. ht_i(ji,jj,jl) > zhimax(ji,jj,jl) .AND. SUM( zaiold(ji,jj,1:jpl) ) < 0.80 ) .OR. &
+                          ( zdv < 0.0 .AND. ht_i(ji,jj,jl) > zhimax(ji,jj,jl) ) ) THEN                                          
+                        ht_i(ji,jj,jl) = MIN( zhimax(ji,jj,jl), hi_max(jl) )
+                        zindh   =  MAX( rzero, SIGN( rone, ht_i(ji,jj,jl) - epsi10 ) )
+                        a_i(ji,jj,jl)  = zindh * v_i(ji,jj,jl) / MAX( ht_i(ji,jj,jl), epsi10 )
+                     ELSE
+                        ht_i(ji,jj,jl) = MAX( MIN( ht_i(ji,jj,jl), hi_max(jl) ), hi_max(jl-1) )
+                        zindh   =  MAX( rzero, SIGN( rone, ht_i(ji,jj,jl) - epsi10 ) )
+                        a_i(ji,jj,jl)  = zindh * v_i(ji,jj,jl) / MAX( ht_i(ji,jj,jl), epsi10 )
+                     ENDIF
+
+                     !zindh   =  MAX( rzero, SIGN( rone, ht_i(ji,jj,jl) - epsi10 ) )
+                     v_i(ji,jj,jl) = a_i(ji,jj,jl) * ht_i(ji,jj,jl)
+                     v_s(ji,jj,jl) = a_i(ji,jj,jl) * ht_s(ji,jj,jl)
+
+                     ! Update mass fluxes (clem)
+                     rdmicif(ji,jj) = rdmicif(ji,jj) + ( v_i(ji,jj,jl) - zvi ) * rhoic
+                     rdmsnif(ji,jj) = rdmsnif(ji,jj) + ( v_s(ji,jj,jl) - zvs ) * rhosn
+
+                  ENDIF
+
+                  diag_trp_vi(ji,jj) = diag_trp_vi(ji,jj) + ( v_i(ji,jj,jl) - zviold(ji,jj,jl) ) / rdt_ice
+
                END DO
             END DO
          END DO
 
+         ! ---
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zs0at(ji,jj) = SUM( zs0a(ji,jj,1:jpl) )
+         !      ato_i(ji,jj) = 1._wp - SUM( a_i(ji,jj,1:jpl) ) !clem@rm-ow-advection
+               zs0at(ji,jj) = SUM( zs0a(ji,jj,1:jpl) ) ! clem@useless??
             END DO
          END DO
@@ -377,9 +475,10 @@
          !----------------------
 
-         zbigval = 1.d+13
+         zbigval = 1.e+13
 
          DO jl = 1, jpl
             DO jj = 1, jpj
                DO ji = 1, jpi
+                  zsmv = zs0sm(ji,jj,jl)
 
                   ! Switches and dummy variables
@@ -387,6 +486,6 @@
                   zusvoic         = 1.0/MAX( v_i(ji,jj,jl) , epsi16 )
                   zrtt            = 173.15 * rone 
-                  zindsn          = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - zeps10 ) )
-                  zindic          = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - zeps10 ) )
+                  zindsn          = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi10 ) )
+                  zindic          = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) )
                   zindb           = MAX( zindsn, zindic )
 
@@ -394,6 +493,5 @@
                   zsal = MAX( MIN( (rhoic-rhosn)/rhoic*sss_m(ji,jj)  , &
                      zusvoic * zs0sm(ji,jj,jl) ), s_i_min ) * v_i(ji,jj,jl)
-                  IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) & 
-                     smv_i(ji,jj,jl) = zindic*zsal + (1.0-zindic)*0.0
+                  IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) smv_i(ji,jj,jl) = zindic*zsal
 
                   zage = MAX( MIN( zbigval, zs0oi(ji,jj,jl) / & 
@@ -403,6 +501,8 @@
                   ! Snow heat content
                   ze              =  MIN( MAX( 0.0, zs0c0(ji,jj,jl)*area(ji,jj) ), zbigval )
-                  e_s(ji,jj,1,jl) = zindsn * ze + (1.0 - zindsn) * 0.0      
-
+                  e_s(ji,jj,1,jl) = zindsn * ze      
+
+                  ! Update salt fluxes (clem)
+                  fsalt_res(ji,jj) = fsalt_res(ji,jj) - ( smv_i(ji,jj,jl) - zsmv ) * rhoic / rdt_ice 
                END DO !ji
             END DO !jj
@@ -414,11 +514,34 @@
                   DO ji = 1, jpi
                      ! Ice heat content
-                     zindic          =  MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - zeps10 ) )
+                     zindic          =  MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) )
                      ze              =  MIN( MAX( 0.0, zs0e(ji,jj,jk,jl)*area(ji,jj) ), zbigval )
-                     e_i(ji,jj,jk,jl) = zindic * ze    + ( 1.0 - zindic ) * 0.0
+                     e_i(ji,jj,jk,jl) = zindic * ze
                   END DO !ji
                END DO ! jj
             END DO ! jk
          END DO ! jl
+
+
+      ! --- agglomerate variables (clem) -----------------
+      vt_i (:,:) = 0._wp
+      vt_s (:,:) = 0._wp
+      at_i (:,:) = 0._wp
+      !
+      DO jl = 1, jpl
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               !
+               vt_i(ji,jj) = vt_i(ji,jj) + v_i(ji,jj,jl) ! ice volume
+               vt_s(ji,jj) = vt_s(ji,jj) + v_s(ji,jj,jl) ! snow volume
+               at_i(ji,jj) = at_i(ji,jj) + a_i(ji,jj,jl) ! ice concentration
+               !
+               zinda = MAX( rzero , SIGN( rone , at_i(ji,jj) - epsi16 ) )
+               icethi(ji,jj) = vt_i(ji,jj) / MAX( at_i(ji,jj) , epsi16 ) * zinda  ! ice thickness
+            END DO
+         END DO
+      END DO
+      ! -------------------------------------------------
+
+
 
       ENDIF
@@ -455,8 +578,28 @@
          END DO
       ENDIF
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_fs  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) ) - zchk_fs_b
+         zchk_fw  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) ) - zchk_fw_b
+ 
+         zchk_v_i = ( glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_v_i_b - ( zchk_fw / rhoic ) ) / rdt_ice
+         zchk_smv = ( glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_smv_b ) / rdt_ice + ( zchk_fs / rhoic )
+
+         IF(lwp) THEN
+            IF (    ABS( zchk_v_i   ) >  1.e-5 ) WRITE(numout,*) 'violation volume [m3/day]     (limtrp) = ',(zchk_v_i * 86400.)
+            IF (    ABS( zchk_smv   ) >  1.e-4 ) WRITE(numout,*) 'violation saline [psu*m3/day] (limtrp) = ',(zchk_smv * 86400.)
+            IF ( MINVAL( v_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation v_i<0  [mm]         (limtrp) = ',(MINVAL(v_i) * 1.e-3)
+            IF ( MINVAL( a_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation a_i<0               (limtrp) = ',MINVAL(a_i)
+         ENDIF
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
       !
       CALL wrk_dealloc( jpi, jpj, zui_u, zvi_v, zsm, zs0at, zs0ow )
       CALL wrk_dealloc( jpi, jpj, jpl, zs0ice, zs0sn, zs0a, zs0c0 , zs0sm , zs0oi )
       CALL wrk_dealloc( jpi, jpj, jkmax, jpl, zs0e )
+
+      CALL wrk_dealloc( jpi,jpj,jpl,zaiold, zhimax )   ! clem
       !
    END SUBROUTINE lim_trp
